program PacEdit;
{ Paccie - Leveleditor - 1.00: fertige Version upgeloaded 02.08.94 }
{                      - 1.01: Anzeige erweitert          03.08.94 }

uses crt,graph,BGIDriv,BGIFont,drivers,intuit;


const fxmax=24; fymax=16; hmax=10; dx=24; dy=24; ox=8; oy=8;
      levelfile='pacciel.';

type feld=array[1..fxmax,1..fymax] of integer;
     bob =record
             x,y,speedx,speedy,zustand,id:integer;
             p_image                     :pointer;
          end;


var i,j,k,lev,xmax,ymax,cmax,key,mx,my,xx,yy,ng:integer;
    ch                  :char;
    ima          :array[0..31] of image;
    bobbie       :array[0..16] of bob;
    ibord1,ibord2:array[0..3] of Border;
    itext1,itext2:array[0..3] of IntuiText;
    itext3       :array[0..9] of intuitext;
    str1,str2    :StrInfo;
    igad         :array[0..23] of Gadget;
    xy1,xy2      :koords;
    ok,fertig    :boolean;
    temp1,temp2  :string;
    f            :feld;

{$i PacEdGra.inc }
{$i PacEdStr.inc }

procedure initfeld;
var i,j:integer;
begin
for i:=1 to 16 do with bobbie[i] do begin
   x:=0; y:=0; speedx:=0; speedy:=0; zustand:=0; id:=i;
end;
bobbie[1].p_image:=addr(ima[0]);
bobbie[2].p_image:=addr(ima[17]);
bobbie[3].p_image:=addr(ima[18]);
bobbie[4].p_image:=addr(ima[16]);
bobbie[5].p_image:=addr(ima[20]);
bobbie[6].p_image:=addr(ima[20]);
bobbie[7].p_image:=addr(ima[20]);
bobbie[8].p_image:=addr(ima[20]);
bobbie[9].p_image:=addr(ima[20]);
bobbie[10].p_image:=addr(ima[20]);
bobbie[11].p_image:=addr(ima[20]);
bobbie[12].p_image:=addr(ima[20]);
bobbie[13].p_image:=addr(ima[20]);
bobbie[14].p_image:=addr(ima[20]);
bobbie[15].p_image:=addr(ima[13]);
bobbie[16].p_image:=addr(ima[5]);

for i:=1 to fxmax do for j:=1 to fymax do f[i,j]:=2;
for i:=1 to fxmax do begin
   f[i,1]:=4;
   f[i,fymax]:=4
end;
for i:=1 to fymax do begin
   f[1,i]:=4;
   f[fxmax,i]:=4
end;
end;


procedure drawelement(x,y:integer);
begin
   if f[x,y] in [2..3] then drawimage(x*dx+ox,y*dy+oy,addr(ima[0]));
   drawimage(x*dx+ox,y*dy+oy,bobbie[f[x,y]].p_image);
   if f[x,y] in [1..3] then drawborder(x*dx+ox,y*dy+oy,addr(ibord1[0]));
   if f[x,y] in [5..14] then
   drawintuitext(x*dx+ox,y*dy+oy,addr(itext3[f[x,y]-5]));
end;

procedure drawfeld;
var i,j,k:integer;
begin
   for i:=1 to fymax do for j:=1 to fxmax do drawelement(j,i);
end;


procedure writemess(mess:string; piep:boolean);
var key,mx,my:integer;
begin
   if piep then write(chr(7));
   rectfill(360,464,623,472,2);
   setcolor(10);
   outtextxy(360,464,mess);
end;

{ -------------------------------------------------------------- }

procedure ladelevel(endung:string; var header:string);
const ckstr=' .o#0123456789*a';
var i,j:integer; istda:boolean; temp:string; ch:char; fh:text;
begin
   temp:=levelfile+endung;
{$i-}
   assign(fh,temp);
   reset(fh);
   readln(fh,temp);
   istda:=ioresult=0;
   if istda then begin
      header:=temp;
      for j:=1 to fymax do begin
         readln(fh,temp);
         for i:=1 to length(temp) do begin
            f[i,j]:=integer(pos(temp[i],ckstr));
            drawelement(i,j);
         end;
      end;
      close(fh);
   end;
{$i+}
end;



procedure savelevel(endung,header:string);
var i,j,k,npaccie,ndots,nhoehlen:integer;
    ok,istda:boolean; temp,zeile,ckstr:string; ch:char;
    fh,fo:text;
    hliste:array[0..9] of record x,y:integer end;
begin
   ckstr:=' .o#0123456789*a';        { ging diesmal nicht als Konstante }

{ Paccie, Dots, Hhlen checken:  }
   for i:=0 to 9 do hliste[i].x:=0;
   npaccie:=0;
   ndots:=0;
   nhoehlen:=0;
   for i:=1 to fxmax do for j:=1 to fymax do begin
      if f[i,j] in [5..14] then begin
         k:=f[i,j]-5;
         inc(nhoehlen);
         hliste[k].x:=i;
         hliste[k].y:=j
      end;
      if f[i,j]=16 then inc(npaccie);
      if f[i,j]=2 then inc(ndots);
   end;
   j:=0;
   for i:=0 to 9 do with hliste[i] do if x>0 then begin
      f[x,y]:=j+5;
      inc(j)
   end;


   ok:=npaccie>0;
   if not ok then begin
      writemess('kein Paccie gesetzt!',true);
      ok:=false;
   end;

   if ndots<5 then begin
      writemess('mindestens 5 Pillen setzen!',true);
      ok:=false;
   end;
   if nhoehlen=1 then begin
      writemess('Wenn schon, dann mind. 2 Hhlen!',true);
      ok:=false;
   end;

if ok then begin
   temp:=levelfile+endung;
{$i-}
   assign(fh,temp);
   reset(fh);
   readln(fh,zeile);
   istda:=ioresult=0;
   if istda then begin
      temp:='B'+temp;
      assign(fo,temp);
      rewrite(fo);
      writeln(fo,zeile);
      for i:=1 to fymax do begin
         readln(fh,zeile); writeln(fo,zeile);
      end;
      close(fh);
      close(fo);
   end;
   temp:=levelfile+endung;
   assign(fh,temp);
   rewrite(fh);
   writeln(fh,header);
   for j:=1 to fymax do begin
      temp:='';
      for i:=1 to fxmax do temp:=temp+ckstr[f[i,j]];
      writeln(fh,temp);
   end;
   close(fh);
{$i+}
   writemess(levelfile+endung+' geschrieben!',false);
end;
drawfeld;
end;



{ ================================================================== }

begin
initscr(xmax,ymax,cmax,ok);
if ok then begin { Bildschirmaufbau }
   initstructures;
   loadimages;
   ima[17].x:=9;
   ima[17].y:=9;
   ima[18].x:=8;
   ima[18].y:=8;
   for i:=1 to 23 do drawgadget(addr(igad[i]));
   lev:=0;
   initfeld;
   drawfeld;
   initmouse;
   fertig:=false;
   temp1:='000';
   temp2:='---------------';
   for i:=21 to 22 do
             with igad[i] do begin
                rectfill(x,y,pred(x+width),pred(y+height),bpen);
                setcolor(14);
                if i=21 then outtextxy(x+2,y+1,temp1)
                else outtextxy(x+2,y+1,temp2);
            end;
   bobbie[0]:=bobbie[1];
   igad[1].onoff:=true;
   drawgadget(addr(igad[1]));



   while not fertig do begin
      gadgetup(addr(igad[1]),i,mx,my);
      if i>0 then begin   { was ist nur mit den Sets los? }
      if i in [1..16] then begin
         bobbie[0]:=bobbie[i];
         for j:=1 to 16 do begin
            igad[j].onoff:=(j=i);
            drawgadget(addr(igad[j]));
         end;
      end;

      if i in [17..22] then case i of
      17: begin
             initfeld;
             drawfeld;
          end;
      18: begin
             ladelevel(temp1,temp2);
             for j:=21 to 22 do
              with igad[j] do begin
                rectfill(x,y,pred(x+width),pred(y+height),bpen);
                setcolor(14);
                if j=21 then outtextxy(x+2,y+1,temp1)
                else outtextxy(x+2,y+1,temp2);
            end;
          end;
      19: savelevel(temp1,temp2);
      20: fertig:=true;
      21: begin
             getstring(igad[i]);
             temp1:=igad[i].p_specialinfo^.buff;
             Val(temp1,k,j);
             if j=0 then if (k>-1) and (k<1000) then lev:=k;
             str(lev:3,temp1);
             for j:=1 to length(temp1) do if temp1[j]=' ' then temp1[j]:='0';
             with igad[i] do begin
                rectfill(x,y,pred(x+width),pred(y+height),bpen);
                setcolor(14);
                outtextxy(x+2,y+1,temp1);
             end;
          end;
      22: begin
             getstring(igad[i]);
             temp2:=igad[i].p_specialinfo^.buff;
             with igad[i] do begin
                rectfill(x,y,pred(x+width),pred(y+height),bpen);
                setcolor(14);
                outtextxy(x+2,y+1,temp2);
             end;
          end;
      end;
      if i=23 then begin { setzeelement, Auenrand schtzen }
         mx:=(mx-ox) div dx;
         if mx<2 then mx:=2; if mx>=fxmax then mx:=pred(fxmax);
         my:=(my-oy) div dy;
         if my<2 then my:=2; if my>=fymax then my:=pred(fymax);
         with bobbie[0] do case id of
            1.. 4: f[mx,my]:=id;
            5..14,16: begin
                      for i:=1 to fxmax do for j:=1 to fymax do
                      if f[i,j]=id then begin
                         f[i,j]:=1;
                         drawelement(i,j);
                      end;
                      f[mx,my]:=id;
                   end;
               15: begin
                      k:=0;
                      for i:=1 to fxmax do for j:=1 to fymax do
                      if f[i,j]=id then begin
                         inc(k); xx:=i; yy:=j;
                      end;
                      if k>7 then begin
                         mx:=xx;
                         my:=yy;
                         writemess('max 8 Kraken!',true);
                      end else f[mx,my]:=id;
                   end;


         end; { with bobbie }
         drawelement(mx,my);
      end; { i=23 }
   end;
   end;
   closegraph;
   textmode(3);
end;
end.
